function out = Distance(parameter);
global M_ oo_ options_ ys0_ ex0_ mom y c n x W sim T M seed method
options_ = [];
M_.fname = 'Hansen';
%
% Some global variables initialization
%
global_initialization;
diary off;
logname_ = 'Hansen.log';
if exist(logname_, 'file')
    delete(logname_)
end
diary(logname_)
M_.exo_names = 'eps_z';
M_.exo_names_tex = 'eps\_z';
M_.endo_names = 'c';
M_.endo_names_tex = 'c';
M_.endo_names = char(M_.endo_names, 'n');
M_.endo_names_tex = char(M_.endo_names_tex, 'n');
M_.endo_names = char(M_.endo_names, 'w');
M_.endo_names_tex = char(M_.endo_names_tex, 'w');
M_.endo_names = char(M_.endo_names, 'x');
M_.endo_names_tex = char(M_.endo_names_tex, 'x');
M_.endo_names = char(M_.endo_names, 'r');
M_.endo_names_tex = char(M_.endo_names_tex, 'r');
M_.endo_names = char(M_.endo_names, 'k');
M_.endo_names_tex = char(M_.endo_names_tex, 'k');
M_.endo_names = char(M_.endo_names, 'y');
M_.endo_names_tex = char(M_.endo_names_tex, 'y');
M_.endo_names = char(M_.endo_names, 'z');
M_.endo_names_tex = char(M_.endo_names_tex, 'z');
M_.param_names = 'eta';
M_.param_names_tex = 'eta';
M_.param_names = char(M_.param_names, 'beta');
M_.param_names_tex = char(M_.param_names_tex, 'beta');
M_.param_names = char(M_.param_names, 'psi');
M_.param_names_tex = char(M_.param_names_tex, 'psi');
M_.param_names = char(M_.param_names, 'delta');
M_.param_names_tex = char(M_.param_names_tex, 'delta');
M_.param_names = char(M_.param_names, 'alpha');
M_.param_names_tex = char(M_.param_names_tex, 'alpha');
M_.param_names = char(M_.param_names, 'rho');
M_.param_names_tex = char(M_.param_names_tex, 'rho');
M_.param_names = char(M_.param_names, 'sigma');
M_.param_names_tex = char(M_.param_names_tex, 'sigma');
M_.param_names = char(M_.param_names, 'kss');
M_.param_names_tex = char(M_.param_names_tex, 'kss');
M_.param_names = char(M_.param_names, 'nss');
M_.param_names_tex = char(M_.param_names_tex, 'nss');
M_.param_names = char(M_.param_names, 'css');
M_.param_names_tex = char(M_.param_names_tex, 'css');
M_.param_names = char(M_.param_names, 'yss');
M_.param_names_tex = char(M_.param_names_tex, 'yss');
M_.param_names = char(M_.param_names, 'xss');
M_.param_names_tex = char(M_.param_names_tex, 'xss');
M_.param_names = char(M_.param_names, 'wss');
M_.param_names_tex = char(M_.param_names_tex, 'wss');
M_.param_names = char(M_.param_names, 'rss');
M_.param_names_tex = char(M_.param_names_tex, 'rss');
M_.param_names = char(M_.param_names, 'betatrans');
M_.param_names_tex = char(M_.param_names_tex, 'betatrans');
M_.param_names = char(M_.param_names, 'rhotrans');
M_.param_names_tex = char(M_.param_names_tex, 'rhotrans');
M_.param_names = char(M_.param_names, 'deltatrans');
M_.param_names_tex = char(M_.param_names_tex, 'deltatrans');
M_.param_names = char(M_.param_names, 'sigmatrans');
M_.param_names_tex = char(M_.param_names_tex, 'sigmatrans');
M_.param_names = char(M_.param_names, 'alphatrans');
M_.param_names_tex = char(M_.param_names_tex, 'alphatrans');
M_.exo_det_nbr = 0;
M_.exo_nbr = 1;
M_.endo_nbr = 8;
M_.param_nbr = 19;
M_.orig_endo_nbr = 8;
M_.aux_vars = [];
M_.Sigma_e = zeros(1, 1);
M_.H = 0;
options_.block=0;
options_.bytecode=0;
options_.use_dll=0;
erase_compiled_function('Hansen_dynamic');
M_.lead_lag_incidence = [
 0 3 11;
 0 4 0;
 0 5 0;
 0 6 0;
 0 7 12;
 1 8 0;
 0 9 0;
 2 10 0;]';
M_.equations_tags = {
};
M_.exo_names_orig_ord = [1:1];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(8, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(1, 1);
M_.params = repmat(NaN,19, 1);
M_.NNZDerivatives = zeros(3, 1);
M_.NNZDerivatives(1) = 24;
M_.NNZDerivatives(2) = -1;
M_.NNZDerivatives(3) = -1;
close all;
M_.params( 15 ) = parameter(1);
betatrans = M_.params( 15 );
M_.params( 2 ) = M_.params(15)^2/(1+M_.params(15)^2);
beta = M_.params( 2 );
M_.params( 3 ) = parameter(2);
psi = M_.params( 3 );
M_.params( 17 ) = sqrt(0.025/(1-0.025));
deltatrans = M_.params( 17 );
M_.params( 4 ) = M_.params(17)^2/(1+M_.params(17)^2);
delta = M_.params( 4 );
M_.params( 19 ) = sqrt(0.36/(1-0.36));
alphatrans = M_.params( 19 );
M_.params( 5 ) = M_.params(19)^2/(1+M_.params(19)^2);
alpha = M_.params( 5 );
M_.params( 16 ) = parameter(3);
rhotrans = M_.params( 16 );
M_.params( 6 ) = M_.params(16)^2/(1+M_.params(16)^2);
rho = M_.params( 6 );
M_.params( 18 ) = parameter(4);
sigmatrans = M_.params( 18 );
M_.params( 7 ) = abs(M_.params(18));
sigma = M_.params( 7 );
M_.params( 1 ) = ((1/M_.params(2)+M_.params(4)-1)/M_.params(5))^(1/(1-M_.params(5)));
eta = M_.params( 1 );
M_.params( 8 ) = (1-M_.params(5))*M_.params(1)^(-M_.params(5))/M_.params(3)*(M_.params(1)^(1-M_.params(5))-M_.params(4))^(-1);
kss = M_.params( 8 );
M_.params( 9 ) = M_.params(1)*M_.params(8);
nss = M_.params( 9 );
M_.params( 11 ) = M_.params(8)^M_.params(5)*M_.params(9)^(1-M_.params(5));
yss = M_.params( 11 );
M_.params( 14 ) = M_.params(5)*M_.params(11)/M_.params(8);
rss = M_.params( 14 );
M_.params( 13 ) = (1-M_.params(5))*M_.params(11)/M_.params(9);
wss = M_.params( 13 );
M_.params( 10 ) = M_.params(13)/M_.params(3);
css = M_.params( 10 );
M_.params( 12 ) = M_.params(4)*M_.params(8);
xss = M_.params( 12 );
zss = 1;
%
% INITVAL instructions
%
options_.initval_file = 0;
oo_.steady_state( 6 ) = M_.params(8);
oo_.steady_state( 2 ) = M_.params(9);
oo_.steady_state( 3 ) = M_.params(13);
oo_.steady_state( 5 ) = M_.params(14);
oo_.steady_state( 7 ) = M_.params(11);
oo_.steady_state( 4 ) = M_.params(12);
oo_.steady_state( 8 ) = zss;
oo_.steady_state( 1 ) = M_.params(10);
oo_.endo_simul=[oo_.steady_state*ones(1,M_.maximum_lag)];
if M_.exo_nbr > 0;
	oo_.exo_simul = [ones(M_.maximum_lag,1)*oo_.exo_steady_state'];
end;
if M_.exo_det_nbr > 0;
	oo_.exo_det_simul = [ones(M_.maximum_lag,1)*oo_.exo_det_steady_state'];
end;
make_ex_;
M_.exo_det_length = 0;
M_.Sigma_e(1, 1) = (M_.params(7))^2;
M_.sigma_e_is_diagonal = 1;
set_dynare_seed(seed);
options_.irf = 0;
options_.order = 1;
options_.periods = M;
options_.noprint=1;
options_.drop = 0;
var_list_=[];
info = stoch_simul(var_list_);
save('Hansen_results.mat', 'oo_', 'M_', 'options_');
diary off
 
%Calculating the moments
%Since the model is solved affin, we need to subtract the steady state
%value of the single observed variables
y = y - oo_.steady_state(7);
c = c - oo_.steady_state(1);
n = n - oo_.steady_state(2);
x = x - oo_.steady_state(4);
datasim = [c x n];
nob = size(datasim,1); % number of observations 
nvar = size(datasim,2); % number of variables
for i = 1:nvar
      for j = i:nvar
        if (i==1) && (j==1)%calculation of variance
            varss = datasim(2:nob,i).*datasim(2:nob,j);
        else%calculation of covariance
            varss = [varss datasim(2:nob,i).*datasim(2:nob,j)];  
        end   
      end
end
autosc1 = datasim(2:nob,:).*datasim(1:nob-1,:);
autosc2 = datasim(3:nob,:).*datasim(1:nob-2,:);
sim = [mean(varss)';mean(autosc1)'; mean(autosc2)'];
out = (sim - mom)'*W*(sim - mom); 